package dep

import (
	"gitee.com/xuyiping_admin/pkg/di"
	"kpt-calf-feed/config"
	"kpt-calf-feed/module/backend"
	"kpt-calf-feed/service/sso"
	"kpt-calf-feed/service/wechat"
	"kpt-calf-feed/store/kptstore"
)

// Global 全局所有的依赖
// 除了:
// * cmd
// * http
// * grpc
func Global() di.HubOption {
	return di.Options(Options()...)
}

func Options() []di.HubOption {
	return []di.HubOption{
		// 基础依赖
		config.Module,
		// store
		kptstore.Module,
		backend.Module,
		sso.Module,
		wechat.Module,
	}
}
